/* ssh-display.c generated by valac 0.40.19, the Vala compiler
 * generated from ssh-display.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "common.h"
#include <stdlib.h>
#include <string.h>
#include <vte/vte.h>
#include <libxml/uri.h>


#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;
typedef enum  {
	BOXES_PROPERTIES_PAGE_GENERAL,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_SNAPSHOTS,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;


#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;

#define BOXES_TYPE_DISPLAY (boxes_display_get_type ())
#define BOXES_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_DISPLAY, BoxesDisplay))
#define BOXES_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_DISPLAY, BoxesDisplayClass))
#define BOXES_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_DISPLAY))
#define BOXES_IS_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_DISPLAY))
#define BOXES_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_DISPLAY, BoxesDisplayClass))

typedef struct _BoxesDisplay BoxesDisplay;
typedef struct _BoxesDisplayClass BoxesDisplayClass;
typedef struct _BoxesDisplayPrivate BoxesDisplayPrivate;
typedef gint (*BoxesDisplayOpenFDFunc) (gpointer user_data);

#define BOXES_TYPE_SSH_DISPLAY (boxes_ssh_display_get_type ())
#define BOXES_SSH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay))
#define BOXES_SSH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplayClass))
#define BOXES_IS_SSH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_SSH_DISPLAY))
#define BOXES_IS_SSH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_SSH_DISPLAY))
#define BOXES_SSH_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplayClass))

typedef struct _BoxesSshDisplay BoxesSshDisplay;
typedef struct _BoxesSshDisplayClass BoxesSshDisplayClass;
typedef struct _BoxesSshDisplayPrivate BoxesSshDisplayPrivate;
enum  {
	BOXES_SSH_DISPLAY_0_PROPERTY,
	BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY,
	BOXES_SSH_DISPLAY_URI_PROPERTY,
	BOXES_SSH_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* boxes_ssh_display_properties[BOXES_SSH_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _xmlFreeURI0(var) ((var == NULL) ? NULL : (var = (xmlFreeURI (var), NULL)))

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

struct _BoxesDisplay {
	GObject parent_instance;
	BoxesDisplayPrivate * priv;
	gboolean connected;
	GHashTable* displays;
};

struct _BoxesDisplayClass {
	GObjectClass parent_class;
	GtkWidget* (*get_display) (BoxesDisplay* self, gint n);
	GdkPixbuf* (*get_pixbuf) (BoxesDisplay* self, gint n, GError** error);
	void (*set_enable_audio) (BoxesDisplay* self, gboolean enable);
	gboolean (*should_keep_alive) (BoxesDisplay* self);
	void (*connect_it) (BoxesDisplay* self, BoxesDisplayOpenFDFunc open_fd, gpointer open_fd_target, GDestroyNotify open_fd_target_destroy_notify, GError** error);
	void (*disconnect_it) (BoxesDisplay* self);
	void (*collect_logs) (BoxesDisplay* self, GString* builder);
	void (*transfer_files) (BoxesDisplay* self, GList* uris);
	void (*send_keys) (BoxesDisplay* self, guint* keyvals, int keyvals_length1);
	GList* (*get_properties) (BoxesDisplay* self, BoxesPropertiesPage page);
	const gchar* (*get_protocol) (BoxesDisplay* self);
	gchar* (*get_uri) (BoxesDisplay* self);
	gboolean (*get_can_transfer_files) (BoxesDisplay* self);
};

struct _BoxesSshDisplay {
	BoxesDisplay parent_instance;
	BoxesSshDisplayPrivate * priv;
};

struct _BoxesSshDisplayClass {
	BoxesDisplayClass parent_class;
};

struct _BoxesSshDisplayPrivate {
	VteTerminal* display;
	gchar* host;
	gchar* user;
	gint port;
	BoxesBoxConfigSavedProperty* saved_properties;
	gint saved_properties_length1;
	gint _saved_properties_size_;
};


static gpointer boxes_ssh_display_parent_class = NULL;

GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_property_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GType boxes_display_get_type (void) G_GNUC_CONST;
GType boxes_ssh_display_get_type (void) G_GNUC_CONST;
#define BOXES_SSH_DISPLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplayPrivate))
static void _vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                                   gint array_length);
BoxesSshDisplay* boxes_ssh_display_new (BoxesBoxConfig* config,
                                        const gchar* host,
                                        gint port,
                                        const gchar* user);
BoxesSshDisplay* boxes_ssh_display_construct (GType object_type,
                                              BoxesBoxConfig* config,
                                              const gchar* host,
                                              gint port,
                                              const gchar* user);
BoxesDisplay* boxes_display_construct (GType object_type);
void boxes_display_set_config (BoxesDisplay* self,
                               BoxesBoxConfig* value);
BoxesSshDisplay* boxes_ssh_display_new_with_uri (BoxesBoxConfig* config,
                                                 const gchar* _uri,
                                                 GError** error);
BoxesSshDisplay* boxes_ssh_display_construct_with_uri (GType object_type,
                                                       BoxesBoxConfig* config,
                                                       const gchar* _uri,
                                                       GError** error);
static GtkWidget* boxes_ssh_display_real_get_display (BoxesDisplay* base,
                                               gint n);
static void boxes_ssh_display_real_set_enable_audio (BoxesDisplay* base,
                                              gboolean enable);
static GdkPixbuf* boxes_ssh_display_real_get_pixbuf (BoxesDisplay* base,
                                              gint n,
                                              GError** error);
static gboolean boxes_ssh_display_run (BoxesSshDisplay* self,
                                gchar** command,
                                int command_length1);
static void boxes_ssh_display_real_connect_it (BoxesDisplay* base,
                                        BoxesDisplayOpenFDFunc open_fd,
                                        gpointer open_fd_target,
                                        GDestroyNotify open_fd_target_destroy_notify,
                                        GError** error);
static void boxes_ssh_display_real_disconnect_it (BoxesDisplay* base);
static GList* boxes_ssh_display_real_get_properties (BoxesDisplay* base,
                                              BoxesPropertiesPage page);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void boxes_ssh_display_real_send_keys (BoxesDisplay* base,
                                       guint* keyvals,
                                       int keyvals_length1);
static GObject * boxes_ssh_display_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _boxes_ssh_display___lambda89_ (BoxesSshDisplay* self);
void boxes_display_access_start (BoxesDisplay* self);
static void __boxes_ssh_display___lambda89__gtk_widget_show (GtkWidget* _sender,
                                                      gpointer self);
static void boxes_ssh_display_finalize (GObject * obj);
const gchar* boxes_display_get_protocol (BoxesDisplay* self);
gchar* boxes_display_get_uri (BoxesDisplay* self);
static void _vala_boxes_ssh_display_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static void
_vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                              gint array_length)
{
#line 12 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (array != NULL) {
#line 209 "ssh-display.c"
		int i;
#line 12 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 12 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			boxes_box_config_saved_property_destroy (&array[i]);
#line 215 "ssh-display.c"
		}
	}
#line 12 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_free (array);
#line 220 "ssh-display.c"
}


BoxesSshDisplay*
boxes_ssh_display_construct (GType object_type,
                             BoxesBoxConfig* config,
                             const gchar* host,
                             gint port,
                             const gchar* user)
{
	BoxesSshDisplay * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	VteTerminal* _tmp2_;
	BoxesBoxConfigSavedProperty* _tmp3_;
	gint _tmp3__length1;
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (config != NULL, NULL);
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) boxes_display_construct (object_type);
#line 26 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_display_set_config ((BoxesDisplay*) self, config);
#line 28 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = g_strdup (user);
#line 28 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->user);
#line 28 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->user = _tmp0_;
#line 29 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = g_strdup (host);
#line 29 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->host);
#line 29 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->host = _tmp1_;
#line 30 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->port = port;
#line 32 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_ = self->priv->display;
#line 32 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3_ = self->priv->saved_properties;
#line 32 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3__length1 = self->priv->saved_properties_length1;
#line 32 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_box_config_save_properties (config, (GObject*) _tmp2_, _tmp3_, _tmp3__length1);
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return self;
#line 271 "ssh-display.c"
}


BoxesSshDisplay*
boxes_ssh_display_new (BoxesBoxConfig* config,
                       const gchar* host,
                       gint port,
                       const gchar* user)
{
#line 25 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return boxes_ssh_display_construct (BOXES_TYPE_SSH_DISPLAY, config, host, port, user);
#line 283 "ssh-display.c"
}


BoxesSshDisplay*
boxes_ssh_display_construct_with_uri (GType object_type,
                                      BoxesBoxConfig* config,
                                      const gchar* _uri,
                                      GError** error)
{
	BoxesSshDisplay * self = NULL;
	xmlURI* uri = NULL;
	xmlURI* _tmp0_;
	xmlURI* _tmp1_;
	const gchar* _tmp2_;
	xmlURI* _tmp4_;
	const gchar* _tmp5_;
	xmlURI* _tmp7_;
	const gchar* _tmp8_;
	xmlURI* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	xmlURI* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_ = 0;
	xmlURI* _tmp16_;
	gint _tmp17_;
	VteTerminal* _tmp20_;
	BoxesBoxConfigSavedProperty* _tmp21_;
	gint _tmp21__length1;
	GError* _inner_error0_ = NULL;
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (config != NULL, NULL);
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (_uri != NULL, NULL);
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) boxes_display_construct (object_type);
#line 36 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_display_set_config ((BoxesDisplay*) self, config);
#line 38 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = xmlParseURI (_uri);
#line 38 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	uri = _tmp0_;
#line 39 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = uri;
#line 39 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_ = _tmp1_->scheme;
#line 39 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (g_strcmp0 (_tmp2_, "ssh") != 0) {
#line 333 "ssh-display.c"
		GError* _tmp3_;
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp3_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is not ssh://");
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_inner_error0_ = _tmp3_;
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		if (_inner_error0_->domain == BOXES_ERROR) {
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_propagate_error (error, _inner_error0_);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_xmlFreeURI0 (uri);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_g_object_unref0 (self);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			return NULL;
#line 349 "ssh-display.c"
		} else {
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_xmlFreeURI0 (uri);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_clear_error (&_inner_error0_);
#line 40 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			return NULL;
#line 359 "ssh-display.c"
		}
	}
#line 42 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp4_ = uri;
#line 42 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp5_ = _tmp4_->server;
#line 42 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (_tmp5_ == NULL) {
#line 368 "ssh-display.c"
		GError* _tmp6_;
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp6_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is missing a server");
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_inner_error0_ = _tmp6_;
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		if (_inner_error0_->domain == BOXES_ERROR) {
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_propagate_error (error, _inner_error0_);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_xmlFreeURI0 (uri);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_g_object_unref0 (self);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			return NULL;
#line 384 "ssh-display.c"
		} else {
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			_xmlFreeURI0 (uri);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			g_clear_error (&_inner_error0_);
#line 43 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
			return NULL;
#line 394 "ssh-display.c"
		}
	}
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp7_ = uri;
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp8_ = _tmp7_->server;
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp9_ = uri;
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp10_ = _tmp9_->path;
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->host);
#line 45 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->host = _tmp11_;
#line 46 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp12_ = uri;
#line 46 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp13_ = _tmp12_->user;
#line 46 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 46 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->user);
#line 46 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->user = _tmp14_;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp16_ = uri;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp17_ = _tmp16_->port;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (_tmp17_ <= 0) {
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp15_ = 22;
#line 429 "ssh-display.c"
	} else {
		xmlURI* _tmp18_;
		gint _tmp19_;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp18_ = uri;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp19_ = _tmp18_->port;
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp15_ = _tmp19_;
#line 439 "ssh-display.c"
	}
#line 47 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->port = _tmp15_;
#line 49 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp20_ = self->priv->display;
#line 49 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp21_ = self->priv->saved_properties;
#line 49 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp21__length1 = self->priv->saved_properties_length1;
#line 49 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_box_config_save_properties (config, (GObject*) _tmp20_, _tmp21_, _tmp21__length1);
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_xmlFreeURI0 (uri);
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return self;
#line 455 "ssh-display.c"
}


BoxesSshDisplay*
boxes_ssh_display_new_with_uri (BoxesBoxConfig* config,
                                const gchar* _uri,
                                GError** error)
{
#line 35 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return boxes_ssh_display_construct_with_uri (BOXES_TYPE_SSH_DISPLAY, config, _uri, error);
#line 466 "ssh-display.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return self ? g_object_ref (self) : NULL;
#line 475 "ssh-display.c"
}


static GtkWidget*
boxes_ssh_display_real_get_display (BoxesDisplay* base,
                                    gint n)
{
	BoxesSshDisplay * self;
	GtkWidget* result = NULL;
	VteTerminal* _tmp0_;
	GtkWidget* _tmp1_;
#line 52 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 53 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = self->priv->display;
#line 53 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 53 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = _tmp1_;
#line 53 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 497 "ssh-display.c"
}


static void
boxes_ssh_display_real_set_enable_audio (BoxesDisplay* base,
                                         gboolean enable)
{
	BoxesSshDisplay * self;
#line 56 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 508 "ssh-display.c"
}


static GdkPixbuf*
boxes_ssh_display_real_get_pixbuf (BoxesDisplay* base,
                                   gint n,
                                   GError** error)
{
	BoxesSshDisplay * self;
	GdkPixbuf* result = NULL;
#line 59 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 60 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = NULL;
#line 60 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 525 "ssh-display.c"
}


static gboolean
boxes_ssh_display_run (BoxesSshDisplay* self,
                       gchar** command,
                       int command_length1)
{
	gboolean result = FALSE;
	GSpawnFlags flags = 0U;
	gboolean _tmp0_ = FALSE;
	VteTerminal* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 63 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 64 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	flags = G_SPAWN_SEARCH_PATH_FROM_ENVP | G_SPAWN_DO_NOT_REAP_CHILD;
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = self->priv->display;
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_ = g_get_home_dir ();
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = vte_terminal_spawn_sync (_tmp1_, VTE_PTY_DEFAULT, _tmp2_, command, NULL, flags, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 552 "ssh-display.c"
		gboolean _tmp3_ = FALSE;
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		g_clear_error (&_inner_error0_);
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		return _tmp3_;
#line 560 "ssh-display.c"
	}
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = _tmp0_;
#line 66 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 566 "ssh-display.c"
}


static void
boxes_ssh_display_real_connect_it (BoxesDisplay* base,
                                   BoxesDisplayOpenFDFunc open_fd,
                                   gpointer open_fd_target,
                                   GDestroyNotify open_fd_target_destroy_notify,
                                   GError** error)
{
	BoxesSshDisplay * self;
	gboolean _tmp0_;
	VteTerminal* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* prefix = NULL;
	gchar* _tmp7_;
	gchar** ssh_connect_cmd = NULL;
	gchar* _tmp8_;
	gint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gint ssh_connect_cmd_length1;
	gint _ssh_connect_cmd_size_;
	gchar** _tmp18_;
	gint _tmp18__length1;
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 71 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = ((BoxesDisplay*) self)->connected;
#line 71 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (_tmp0_) {
#line 72 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
#line 72 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		open_fd = NULL;
#line 72 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		open_fd_target = NULL;
#line 72 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		open_fd_target_destroy_notify = NULL;
#line 72 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		return;
#line 616 "ssh-display.c"
	}
#line 73 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplay*) self)->connected = TRUE;
#line 75 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = self->priv->display;
#line 75 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3_ = self->priv->user;
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	if (g_strcmp0 (_tmp3_, "") != 0) {
#line 628 "ssh-display.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp4_ = self->priv->user;
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp5_ = g_strconcat (_tmp4_, "@", NULL);
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_g_free0 (_tmp2_);
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp2_ = _tmp5_;
#line 639 "ssh-display.c"
	} else {
		gchar* _tmp6_;
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp6_ = g_strdup ("");
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_g_free0 (_tmp2_);
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		_tmp2_ = _tmp6_;
#line 648 "ssh-display.c"
	}
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp7_ = g_strdup (_tmp2_);
#line 77 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	prefix = _tmp7_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp8_ = g_strdup ("ssh");
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp9_ = self->priv->port;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp10_ = g_strdup_printf ("%i", _tmp9_);
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp11_ = _tmp10_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp12_ = g_strconcat ("-p ", _tmp11_, NULL);
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp13_ = prefix;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp14_ = self->priv->host;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp16_ = g_new0 (gchar*, 3 + 1);
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp16_[0] = _tmp8_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp16_[1] = _tmp12_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp16_[2] = _tmp15_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp17_ = _tmp16_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp17__length1 = 3;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (_tmp11_);
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	ssh_connect_cmd = _tmp17_;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	ssh_connect_cmd_length1 = _tmp17__length1;
#line 78 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_ssh_connect_cmd_size_ = ssh_connect_cmd_length1;
#line 82 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp18_ = ssh_connect_cmd;
#line 82 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp18__length1 = ssh_connect_cmd_length1;
#line 82 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_ssh_display_run (self, _tmp18_, _tmp18__length1);
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	ssh_connect_cmd = (_vala_array_free (ssh_connect_cmd, ssh_connect_cmd_length1, (GDestroyNotify) g_free), NULL);
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (prefix);
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (_tmp2_);
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	open_fd = NULL;
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	open_fd_target = NULL;
#line 69 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	open_fd_target_destroy_notify = NULL;
#line 710 "ssh-display.c"
}


static void
boxes_ssh_display_real_disconnect_it (BoxesDisplay* base)
{
	BoxesSshDisplay * self;
#line 85 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 720 "ssh-display.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 88 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 729 "ssh-display.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 88 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 738 "ssh-display.c"
}


static GList*
boxes_ssh_display_real_get_properties (BoxesDisplay* base,
                                       BoxesPropertiesPage page)
{
	BoxesSshDisplay * self;
	GList* result = NULL;
	GList* list = NULL;
#line 88 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 89 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	list = NULL;
#line 91 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = list;
#line 91 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 757 "ssh-display.c"
}


static void
boxes_ssh_display_real_send_keys (BoxesDisplay* base,
                                  guint* keyvals,
                                  int keyvals_length1)
{
	BoxesSshDisplay * self;
#line 94 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 769 "ssh-display.c"
}


static const gchar*
boxes_ssh_display_real_get_protocol (BoxesDisplay* base)
{
	const gchar* result;
	BoxesSshDisplay* self;
#line 6 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 6 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = "SSH";
#line 6 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 784 "ssh-display.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1515 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = self;
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 798 "ssh-display.c"
}


static gchar*
boxes_ssh_display_real_get_uri (BoxesDisplay* base)
{
	gchar* result;
	BoxesSshDisplay* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = (BoxesSshDisplay*) base;
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = self->priv->user;
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_ = self->priv->host;
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp4_ = g_strconcat ("ssh://", _tmp1_, "@", _tmp3_, NULL);
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	result = _tmp4_;
#line 7 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return result;
#line 828 "ssh-display.c"
}


static void
_boxes_ssh_display___lambda89_ (BoxesSshDisplay* self)
{
#line 20 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_signal_emit_by_name ((BoxesDisplay*) self, "show", 0);
#line 21 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_display_access_start ((BoxesDisplay*) self);
#line 839 "ssh-display.c"
}


static void
__boxes_ssh_display___lambda89__gtk_widget_show (GtkWidget* _sender,
                                                 gpointer self)
{
#line 19 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_boxes_ssh_display___lambda89_ ((BoxesSshDisplay*) self);
#line 849 "ssh-display.c"
}


static GObject *
boxes_ssh_display_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoxesSshDisplay * self;
	gchar* _tmp0_;
	GValue _tmp1_ = {0};
	BoxesBoxConfigSavedProperty _tmp2_ = {0};
	BoxesBoxConfigSavedProperty* _tmp3_;
	VteTerminal* _tmp4_;
	VteTerminal* _tmp5_;
#line 14 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	parent_class = G_OBJECT_CLASS (boxes_ssh_display_parent_class);
#line 14 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 14 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = g_strdup ("read-only");
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_value_set_boolean (&_tmp1_, FALSE);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	memset (&_tmp2_, 0, sizeof (BoxesBoxConfigSavedProperty));
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (_tmp2_.name);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_.name = _tmp0_;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	G_IS_VALUE (&_tmp2_.default_value) ? (g_value_unset (&_tmp2_.default_value), NULL) : NULL;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp2_.default_value = _tmp1_;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3_ = g_new0 (BoxesBoxConfigSavedProperty, 1);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp3_[0] = _tmp2_;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->saved_properties = _tmp3_;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->saved_properties_length1 = 1;
#line 15 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->_saved_properties_size_ = self->priv->saved_properties_length1;
#line 18 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp4_ = (VteTerminal*) vte_terminal_new ();
#line 18 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_object_ref_sink (_tmp4_);
#line 18 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_object_unref0 (self->priv->display);
#line 18 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->display = _tmp4_;
#line 19 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp5_ = self->priv->display;
#line 19 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "show", (GCallback) __boxes_ssh_display___lambda89__gtk_widget_show, self, 0);
#line 14 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	return obj;
#line 915 "ssh-display.c"
}


static void
boxes_ssh_display_class_init (BoxesSshDisplayClass * klass)
{
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	boxes_ssh_display_parent_class = g_type_class_peek_parent (klass);
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_type_class_add_private (klass, sizeof (BoxesSshDisplayPrivate));
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->get_display = (GtkWidget* (*) (BoxesDisplay*, gint)) boxes_ssh_display_real_get_display;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->set_enable_audio = (void (*) (BoxesDisplay*, gboolean)) boxes_ssh_display_real_set_enable_audio;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (BoxesDisplay*, gint, GError**)) boxes_ssh_display_real_get_pixbuf;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->connect_it = (void (*) (BoxesDisplay*, BoxesDisplayOpenFDFunc, gpointer, GDestroyNotify, GError**)) boxes_ssh_display_real_connect_it;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->disconnect_it = (void (*) (BoxesDisplay*)) boxes_ssh_display_real_disconnect_it;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->get_properties = (GList* (*) (BoxesDisplay*, BoxesPropertiesPage)) boxes_ssh_display_real_get_properties;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	((BoxesDisplayClass *) klass)->send_keys = (void (*) (BoxesDisplay*, guint*, int)) boxes_ssh_display_real_send_keys;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	BOXES_DISPLAY_CLASS (klass)->get_protocol = boxes_ssh_display_real_get_protocol;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	BOXES_DISPLAY_CLASS (klass)->get_uri = boxes_ssh_display_real_get_uri;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_ssh_display_get_property;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	G_OBJECT_CLASS (klass)->constructor = boxes_ssh_display_constructor;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_ssh_display_finalize;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY, boxes_ssh_display_properties[BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_SSH_DISPLAY_URI_PROPERTY, boxes_ssh_display_properties[BOXES_SSH_DISPLAY_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 954 "ssh-display.c"
}


static void
boxes_ssh_display_instance_init (BoxesSshDisplay * self)
{
	gchar* _tmp0_;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv = BOXES_SSH_DISPLAY_GET_PRIVATE (self);
#line 10 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_tmp0_ = g_strdup ("");
#line 10 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->user = _tmp0_;
#line 968 "ssh-display.c"
}


static void
boxes_ssh_display_finalize (GObject * obj)
{
	BoxesSshDisplay * self;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
#line 8 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_object_unref0 (self->priv->display);
#line 9 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->host);
#line 10 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	_g_free0 (self->priv->user);
#line 12 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	G_OBJECT_CLASS (boxes_ssh_display_parent_class)->finalize (obj);
#line 988 "ssh-display.c"
}


GType
boxes_ssh_display_get_type (void)
{
	static volatile gsize boxes_ssh_display_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_ssh_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesSshDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_ssh_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesSshDisplay), 0, (GInstanceInitFunc) boxes_ssh_display_instance_init, NULL };
		GType boxes_ssh_display_type_id;
		boxes_ssh_display_type_id = g_type_register_static (BOXES_TYPE_DISPLAY, "BoxesSshDisplay", &g_define_type_info, 0);
		g_once_init_leave (&boxes_ssh_display_type_id__volatile, boxes_ssh_display_type_id);
	}
	return boxes_ssh_display_type_id__volatile;
}


static void
_vala_boxes_ssh_display_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	BoxesSshDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
	switch (property_id) {
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		case BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY:
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		g_value_set_string (value, boxes_display_get_protocol ((BoxesDisplay*) self));
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		break;
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		case BOXES_SSH_DISPLAY_URI_PROPERTY:
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		g_value_take_string (value, boxes_display_get_uri ((BoxesDisplay*) self));
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		break;
#line 1028 "ssh-display.c"
		default:
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 5 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/ssh-display.vala"
		break;
#line 1034 "ssh-display.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1046 "ssh-display.c"
		int i;
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1054 "ssh-display.c"
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 574 "/builddir/build/BUILD/gnome-boxes-3.36.5/src/libvirt-machine.vala"
	g_free (array);
#line 1070 "ssh-display.c"
}



